com.arm.cmsis.zone.gen.data

## Class FmBlock

- java.lang.Object
- - com.arm.cmsis.zone.gen.data.FmBlock

-     public class FmBlock
      extends java.lang.Object

  Block - Generator Data Model Element A block specifies the properties for a certain area of logical memory.
  Author:
    Jonatan Antoni

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `FmBlock(com.arm.cmsis.zone.data.ICpMemoryBlock block)` Create a Block generator data model element.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Collection<FmCapture>` | `getCaptureList()` Get a collection of capture elements for this block.
    `java.lang.String` | `getInfo()` Get the brief description for this block.
    `java.util.Map<java.lang.Long,FmInterrupt>` | `getInterrupts()` Get a hash with available interrupts.
    `java.lang.String` | `getName()` Get the blocks name.
    `java.util.Map<java.lang.String,java.lang.String>` | `getProperties()` Get a hash with associated key-values-properties.
    `long` | `getSize()` Get the size of this block in bytes.
    `long` | `getStart()` Get the start address of this block.
    `java.util.Collection<FmBlock>` | `getSubBlocks()` Get a collection of blocks this one is divided into.
    `boolean` | `isCallable()` Get non-secure-callable access attribute.
    `boolean` | `isExecutable()` Get executable access attribute.
    `boolean` | `isNonSecure()` Get non-secure access attribute.
    `boolean` | `isPeripheral()` Get peripheral access attribute.
    `boolean` | `isPrivileged()` Get privileged access attribute.
    `boolean` | `isReadable()` Get readable access attribute.
    `boolean` | `isSecure()` Get secure access attribute.
    `boolean` | `isUnprivileged()` Get unprivileged access attribute.
    `boolean` | `isWriteable()` Get writeable access attribute.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FmBlock

          public FmBlock(com.arm.cmsis.zone.data.ICpMemoryBlock block)

      Create a Block generator data model element.
      Parameters:
        `block` - The storage data model element to wrap.

  - ### Method Detail

    - #### getName

          public java.lang.String getName()

      Get the blocks name.
      Returns:
        Block name.

    - #### isSecure

          public boolean isSecure()

      Get secure access attribute.
      Returns:
        True if block is used as secure access.

    - #### isCallable

          public boolean isCallable()

      Get non-secure-callable access attribute.
      Returns:
        True if block is used as non-secure-callable access.

    - #### isNonSecure

          public boolean isNonSecure()

      Get non-secure access attribute.
      Returns:
        True if block is used as non-secure access.

    - #### isPeripheral

          public boolean isPeripheral()

      Get peripheral access attribute. Peripheral access denotes a memory area used for peripheral register access.
      Returns:
        True if block is used as peripheral access.

    - #### isReadable

          public boolean isReadable()

      Get readable access attribute.
      Returns:
        True if block is readable.

    - #### isWriteable

          public boolean isWriteable()

      Get writeable access attribute.
      Returns:
        True if block is writeable.

    - #### isExecutable

          public boolean isExecutable()

      Get executable access attribute.
      Returns:
        True if block is executable.

    - #### isUnprivileged

          public boolean isUnprivileged()

      Get unprivileged access attribute.
      Returns:
        True if block can be accessed unprivileged.

    - #### isPrivileged

          public boolean isPrivileged()

      Get privileged access attribute.
      Returns:
        True if block can only be accessed privileged.

    - #### getInterrupts

          public java.util.Map<java.lang.Long,FmInterrupt> getInterrupts()

      Get a hash with available interrupts. The hash associates available interrupt numbers with model elements specifying their properties.
      Returns:
        Hash of available interrupts

    - #### getStart

          public long getStart()

      Get the start address of this block.
      Returns:
        Start address

    - #### getSize

          public long getSize()

      Get the size of this block in bytes.
      Returns:
        Size in bytes

    - #### getInfo

          public java.lang.String getInfo()

      Get the brief description for this block.
      Returns:
        Brief description, may be empty.

    - #### getCaptureList

          public java.util.Collection<FmCapture> getCaptureList()

      Get a collection of capture elements for this block. The capture elements define the set of linker symbols that should be placed to the block.
      Returns:
        Collection of capture elements

    - #### getProperties

          public java.util.Map<java.lang.String,java.lang.String> getProperties()

      Get a hash with associated key-values-properties. The hash associates arbitrary property-keys with their values (represented as strings). The properties are extracted directly from the storage data model.
      Returns:
        Hash of arbitrary properties as key-value-pairs

    - #### getSubBlocks

          public java.util.Collection<FmBlock> getSubBlocks()

      Get a collection of blocks this one is divided into.
      Returns:
        Collection of sub-blocks.